#include <stdio.h>
#include <stdlib.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/event.h>
#include <string.h>
#include <unistd.h>

int main() {
    int socket_listen_fd,
        port_num = 2339,
        client_len,
        socket_connection_fd,
        kq,
        new_events;

    struct kevent change_event, event;
    struct kevent evList[32];
    struct sockaddr_in serv_addr, client_addr;

    if (((socket_listen_fd = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0))
    {
        perror("Failed creating socket");
        exit(1);
    }
    
    bzero((char *)&serv_addr, sizeof(serv_addr));
    serv_addr.sin_family = AF_INET;
    serv_addr.sin_addr.s_addr = INADDR_ANY;
    serv_addr.sin_port = htons(port_num);
    
    if (bind(socket_listen_fd, (struct sockaddr *)&serv_addr, sizeof(serv_addr)) < 0) 
        { perror("Failed binding socket"); exit(1);
    }

    listen(socket_listen_fd, 3);
    client_len = sizeof(client_addr);

    // kqueue SETUP
    
    kq = kqueue();

    EV_SET(&change_event, socket_listen_fd, EVFILT_READ, EV_ADD | EV_ENABLE, 0, 0, 0);
    if (kevent(kq, &change_event, 1, NULL, 0, NULL) == -1)
    {
        perror("Failed create kevent");
        exit(1);
    }

    for (;;)
    {

        new_events = kevent(kq, NULL, 0, evList, 1, NULL);

        // printf("New events ->  %d\n", new_events);

        if (new_events == -1)
        {
            perror("Failed create new kevent");
            exit(1);
        }

        for (int i = 0; new_events > i; i++)
        {
            printf("Amount of new events : %d\n", new_events);
            int event_fd = evList[i].ident;

            if (evList[i].flags & EV_EOF)
            {
                printf("Client disconnected...\n");
                close(event_fd);
            }

            else if (event_fd == socket_listen_fd)
            {
                printf("New connection coming in...\n");

                socket_connection_fd = accept(event_fd, (struct sockaddr *)&client_addr, (socklen_t *)&client_len);
                if (socket_connection_fd == -1)
                {
                    perror("Failed to accept connection...");
                }

                EV_SET(&change_event, socket_connection_fd, EVFILT_READ, EV_ADD, 0, 0, NULL);
                if (kevent(kq, &change_event, 1, NULL, 0, NULL) < 0)
                {
                    perror("Kevent failed to maintain connection");
                }

            }

            else if (evList[i].filter == EVFILT_READ)
            {
                char buf[1024];
                size_t bytes_read = recv(event_fd, buf, sizeof(buf), 0);
                printf("--------------------------------------------------\n");
                printf("Reading %zu bytes\n", bytes_read);
                printf("Incoming msg : %s", buf);
                printf("--------------------------------------------------\n");

                char s_buf[1024];
                int len;
                char *message = "[+] Hello from kTCP\n";

                strcpy(s_buf, message);

                send(event_fd, s_buf, strlen(s_buf), 0);

            }
        }
    }
    
    return 0;

}
